(function (factory) {
    if (typeof module === 'object' && typeof module.exports === 'object') {
        var v = factory(require, exports); if (v !== undefined) module.exports = v;
    }
    else if (typeof define === 'function' && define.amd) {
        define(["require", "exports", 'dojo-shim/WeakMap', 'dojo-compose/compose'], factory);
    }
})(function (require, exports) {
    "use strict";
    var WeakMap_1 = require('dojo-shim/WeakMap');
    var compose_1 = require('dojo-compose/compose');
    var instanceStateMap = new WeakMap_1.default();
    var createCompoundQuery = compose_1.default({
        queryType: 3 /* Compound */,
        apply: function (data) {
            var state = instanceStateMap.get(this);
            return state.finalQuery.apply(state.queries.reduce(function (prev, next) {
                return next.apply(prev);
            }, data));
        },
        withQuery: function (query) {
            var state = instanceStateMap.get(this);
            var isCompound = query.queryType === 3 /* Compound */;
            var compundQuery = query;
            var queries = state.queries.concat([state.finalQuery], (isCompound ? instanceStateMap.get(compundQuery).queries : []));
            var finalQuery = isCompound ? instanceStateMap.get(compundQuery).finalQuery : query;
            var newQuery = createCompoundQuery({ query: finalQuery });
            var newQueryState = instanceStateMap.get(newQuery);
            newQueryState.queries = queries;
            return newQuery;
        },
        toString: function (querySerializer) {
            var state = instanceStateMap.get(this);
            return (querySerializer || state.queryStringBuilder)(this);
        },
        get incremental() {
            var state = instanceStateMap.get(this);
            return state.queries.concat([state.finalQuery]).every(function (query) {
                return Boolean(query.incremental);
            });
        }
    }, function (instance, options) {
        instanceStateMap.set(instance, {
            finalQuery: options.query,
            queries: [],
            queryStringBuilder: options.queryStringBuilder || function (query) {
                var state = instanceStateMap.get(query);
                return state.queries.concat([state.finalQuery]).join('&');
            }
        });
    });
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.default = createCompoundQuery;
});
//# sourceMappingURL=createCompoundQuery.js.map