import Promise from 'dojo-shim/Promise';
import { Subscribable, Observable } from 'rxjs/Observable';
/**
 * Adds a then method to the observable for those consumers of the store API who
 * only want to know about the end result of an operation, and don't want to deal with
 * any recoverable failures.
 */
export declare type StoreObservable<T, U> = Subscribable<U> & Promise<T[]>;
export default function createStoreObservable<T, U>(observable: Observable<U>, transform: (data: U) => T[]): StoreObservable<T, U>;
