import { StoreOptions, CrudOptions, Store, UpdateResults } from './createStore';
import { ComposeFactory } from 'dojo-compose/compose';
export interface SubcollectionOptions<T, O extends CrudOptions, U extends UpdateResults<T>> extends StoreOptions<T, O> {
    source?: Store<T, O, U>;
}
/**
 * This type is primarily intended for consumption by other mixins that require knowledge of a store's
 * source, e.g. querying/tracking.
 */
export interface SubcollectionStore<T, O extends CrudOptions, U extends UpdateResults<T>, C extends Store<T, O, U>> extends Store<T, O, U> {
    createSubcollection(options?: {}): C & this;
    readonly source: (C & this) | undefined;
    readonly factory: (options: O) => (C & this) | undefined;
    getOptions(): SubcollectionOptions<T, O, U>;
}
export interface SubcollectionFactory extends ComposeFactory<SubcollectionStore<{}, {}, any, SubcollectionStore<{}, {}, any, any>>, SubcollectionOptions<{}, {}, any>> {
    <T extends {}, O extends CrudOptions>(options?: SubcollectionOptions<T, O, UpdateResults<T>>): SubcollectionStore<T, O, UpdateResults<T>, Store<T, O, UpdateResults<T>>>;
}
declare const createSubcollectionStore: SubcollectionFactory;
export default createSubcollectionStore;
